#!BPY
# add here "simple" or common  primitives functions that could be used by procedural libraries in libraries/lib_name/building_proc.py

def addFaces(face,pface) :
	fac=[]
	for i, f in enumerate(face):
		if f:fac.append(pface[i])
	return fac
	
#  add lists of verts and faces to some main lists
def listsToLists(lists,listtoadd) :
	offset=len(lists[0])
	for f in listtoadd[1]:
		for i in range(len(f)):f[i]+=offset
	if len(listtoadd[2])<len(listtoadd[1]) :
		sm=listtoadd[2][0]
		listtoadd[2]=[]
		for s in range(len(listtoadd[1])) : listtoadd[2].append(sm)
	lists[0].extend(listtoadd[0])
	lists[1].extend(listtoadd[1])
	lists[2].extend(listtoadd[2])

# converts mesh verts and faces to reinjectable lists of verts, faces, mats... (wip)
def meshToLists(source) :
	vertList=[]
	for v in source.verts : vertList.append([v.co[0],v.co[1],v.co[2]])
	faceList=[]
	smoothList=[]
	for f in source.faces :
		facesubList=[]
		for v in f.verts :facesubList.append(v.index)
		faceList.append(facesubList)
		smoothList.append(f.smooth)
	return [vertList,faceList,smoothList]

# create a temporary mesh for lists of verts and faces, traslate/rotate, then append to a main lists of verts/faces (the city)
def addSide(list,meshlist,transmat,rotmat) :
	meTmp=Mesh.Get("tmpMesh")
	meTmp.verts.extend(meshlist[0])
	meTmp.transform(rotmat, recalc_normals=False, selected_only=False)
	meTmp.transform(transmat, recalc_normals=False, selected_only=False)
	meshlist[0]=[]
	for v in meTmp.verts : meshlist[0].append([v.co[0],v.co[1],v.co[2]])
	listsToLists(list,meshlist)
	meTmp.verts.delete(range(len(meTmp.verts)))

def newMat(mat,newmat):
	for m in newmat:
		if m==0:m=1
		mat.append(m-1)

# gives the corner widths (per side) and the number of window/interwindow unit : Corner | Window | Inter | Window | Inter | Window | Corner
def cutX(width,unit1,unit2,minCorner=0) :
	nbU=int(width/(unit1+unit2))
	#while ((width-nbU*(unit1+unit2)) )/2 < minCorner :
	#	nbU -=1
	corner=((width-nbU*(unit1+unit2)) )/2 +unit2/2
	return nbU,corner
def Cut(width,cuts,nbcuts=0,inter=False,repeat=False,mincorner=0.5,nbseq=False) :
	if nbcuts==1 : return [width],[0]
	widths=[]
	sequence=[]
	tot=0
	if nbseq :
		repeat=True
		inter=False
		mincorner=0
	width -=mincorner*2
	owidth=width
	if inter :
		if len(cuts[0])==2 :int=Puniform(cuts[0][0],cuts[0][1])
		else : int=cuts[0][0]
		widths.append(int)
		id=1
	else :
		id=0
		int=0
	if nbcuts==0 :nbcuts=len(cuts)-id
	i2=0
	for i in range(nbcuts) :
		if nbseq : maxwidth=width/(nbcuts-i)
		else :maxwidth=width
		if nbseq and i==nbcuts-1 : break
		if len(cuts)-id==nbcuts : idcut=id+i
		else : idcut=id+i2
		if len(cuts[idcut])==2 :widths.append(Puniform(min(cuts[idcut][0],maxwidth),min(cuts[idcut][1],maxwidth)))
		else : widths.append(min(maxwidth,cuts[idcut][0]))
		if len(cuts)-id<nbcuts :
			i2 +=1
			if i2>len(cuts)-id-1:i2=0
		#print cuts[idcut][0],maxwidth,widths[-1]
		width -=widths[-1]
	ctrl1=min(widths)
	ctrl2=max(widths)
	notfirst=False
	i2=id
	width=owidth
	while width>=0 :
		if nbseq and i2==nbcuts-1 :break
		if width-int<=ctrl1 :break
		if width-int<=ctrl2 :
			ip=-1
			part=-1
			for i in range(id,nbcuts) :
				if widths[i]<=width-int :
					part=max(i,ip)
					ip=i
			if part==-1 :break
		else : 
			if repeat :
				if i2 >= len(widths):i2=id
				part=i2
			else :part=Prandint(id,len(widths)-1)
		if int>0 and notfirst : 
			sequence.append(0)
			width -=int
		notfirst=True
		sequence.append(part)
		width -=widths[part]
		tot +=1
		i2 +=1
	if nbseq == False :
		sequence.insert(0, len(widths))
		sequence.append(len(widths))
		widths.append(width/2+mincorner)
	else :
		widths.append(width)
		sequence.append(i2)
	return widths,sequence
	
def createCube(list,pos,size,myMats=[],strech=[[0,0],[0,0],[0,0],[0,0]],face=[1,1,1,1,1,0],sizeFactor=[0,0,0],smooth=False):
	# VARIABLES:
	# np: new position
	# ns: new size
	np=[pos[0]-size[0]*sizeFactor[0],pos[1]-size[1]*sizeFactor[1],pos[2]-size[2]*sizeFactor[2]]
	ns=[size[0]+size[0]*sizeFactor[0]*2,size[1]+size[1]*sizeFactor[1]*2,\
		size[2]+size[2]*sizeFactor[2]*2]
	verts=[[np[0],np[1],np[2]],\
		[np[0]+ns[0],np[1],np[2]],\
		[np[0],np[1]+ns[1],np[2]],\
		[np[0]+ns[0],np[1]+ns[1],np[2]],\
		[np[0]+strech[0][0],np[1]+strech[0][1],np[2]+ns[2]],\
		[np[0]+ns[0]-strech[1][0],np[1]+strech[1][1],np[2]+ns[2]],\
		[np[0]+strech[2][0],np[1]+ns[1]-strech[2][1],np[2]+ns[2]],\
		[np[0]+ns[0]-strech[3][0],np[1]+ns[1]-strech[3][1],np[2]+ns[2]]]
	pface=[[0,1,5,4],[1,3,7,5],[3,2,6,7],[2,0,4,6],[4,5,7,6],[2,3,1,0]]
	face=addFaces(face,pface)
	if smooth == False:smooth=[0]
	listsToLists(list,[verts,face,[0]])
	if len(myMats)>0 : newMat(list[3],myMats)
	
# face [3,2,6,7] North
# face [0,1,5,4] South
# face [1,3,7,5] East
# face [2,0,4,6] West
# face [4,5,7,6] Top
def createPyramid(list,pos,size,face=[1,1,1,1,0],sizeFactor=[0,0,0],smooth=False):
	np=[pos[0], pos[1], pos[2]]
	ns=[size[0], size[1],size[2]]
	verts=[[np[0],np[1],np[2]],\
		[np[0]+ns[0],np[1],np[2]],\
		[np[0],np[1]+ns[1],np[2]],\
		[np[0]+ns[0],np[1]+ns[1],np[2]],\
		[np[0]+ns[0]/2,np[1]+ns[1]/2,np[2]+ns[2]]]
	pface=[[0,1,4],[1,3,4],[2,3,4],[2,0,4],[2,3,1,0]]	
	face=addFaces(face,pface)
	if smooth == False:smooth=[[0]]
	listsToLists(list,[verts,face,[0]])


def createPlane(list,pos,size,myMats=[],sizeFactor=[0,0,0]):
	# VARIABLES:
	# np: new position
	# ns: new size
	np=[pos[0]-size[0]*sizeFactor[0] , pos[1]-size[1]*sizeFactor[1] , pos[2]-size[2]*sizeFactor[2]]
	ns=[size[0]+size[0]*sizeFactor[0]*2 , size[1]+size[1]*sizeFactor[1]*2,\
		size[2]+size[2]*sizeFactor[2]*2]
	# horizontal
	if ns[2]==0 :
		verts=[[np[0],np[1],np[2]],\
			[np[0]+ns[0],np[1],np[2]],\
			[np[0],np[1]+ns[1],np[2]],\
			[np[0]+ns[0],np[1]+ns[1],np[2]]]
	# vertical X axis
	elif ns[1]==0 :
		verts=[[np[0],np[1],np[2]],\
			[np[0]+ns[0],np[1],np[2]],\
			[np[0],np[1],np[2]+ns[2]],\
			[np[0]+ns[0],np[1],np[2]+ns[2]]]
	# vertical Y axis
	elif ns[0]==0 :
		verts=[[np[0],np[1],np[2]],\
			[np[0],np[1]+ns[1],np[2]],\
			[np[0],np[1],np[2]+ns[2]],\
			[np[0],np[1]+ns[1],np[2]+ns[2]]]
	face=[[0,1,3,2]]
	smooth=[0]
	listsToLists(list,[verts,face,[0]])
	if len(myMats)>0 : newMat(list[3],myMats)
	
def createWalls(list,pos,bsz,mymats,thickness,face=[1,1,1,1,1]) :
	face=[1,1,1,1,1,0]
	mats=[mymats[1],mymats[1],mymats[1],mymats[1],mymats[1]]
	createCube(list,(pos[0],pos[1],pos[2]),(bsz[0],thickness,bsz[2]),mats,face=face)
	mats=[mymats[1],mymats[1],mymats[1],mymats[1],mymats[1]]
	createCube(list,(pos[0],pos[1]+bsz[1]-thickness,pos[2]),(bsz[0],thickness,bsz[2]),mats,face=face)
	face=[0,1,0,1,1,0]
	mats=[mymats[1],mymats[1],mymats[1]]
	createCube(list,(pos[0],pos[1]+thickness,pos[2]),(thickness,bsz[1]-thickness*2,bsz[2]),mats,face=face)
	mats=[mymats[1],mymats[1],mymats[1]]
	createCube(list,(pos[0]+bsz[0]-thickness,pos[1]+thickness,pos[2]),(thickness,bsz[1]-thickness*2,bsz[2]),mats,face=face)		
	#mats=[mymats[0]]
	createPlane(list,(pos[0]+thickness,pos[1]+thickness,pos[2]),(bsz[0]-thickness*2,bsz[1]-thickness*2,0))
	newMat(list[3],[mymats[0]])

def CreateCylinder(list,pos,size,mat,myMats,sub,ends=True,smooth=True,center=True) :
	diam=size[0]
	scale=size[1]/size[0]
	m=[]
	if ends :
		meTmp=Mesh.Primitives.Cylinder(sub,diam,size[2])
		for i in range(sub) :m.append(myMats[1])
		for i in range(sub) :m.append(myMats[1])
	else:meTmp=Mesh.Primitives.Tube(sub,diam,size[2])
	
	if smooth :
		for f in meTmp.faces :f.smooth=1
	if center :transmat = TranslationMatrix(Vector([pos[0],pos[1],pos[2]+size[2]/2]))
	else :transmat = TranslationMatrix(Vector([pos[0]+size[0]/2,pos[1]+size[1]/2,pos[2]+size[2]/2]))
	scalemat=ScaleMatrix(scale, 4, Vector([0,1,0]))
	meTmp.transform(scalemat, recalc_normals=False, selected_only=False)
	meTmp.transform(transmat, recalc_normals=False, selected_only=False)
	meshlist=meshToLists(meTmp)
	listsToLists(list,meshlist)
	if len(myMats)==2 :
		for i in range(sub) :m.append(myMats[0])
	else : m.extend(myMats)
	newMat(mat,m)

def CreateCone(list,pos,size,mat,myMats,sub,ends=True,smooth=True,center=True) :
	diam=size[0]
	scale=size[1]/size[0]
	m=[]
	meTmp=Mesh.Primitives.Cone(sub,diam,size[2])
	for i in range(sub*2) :m.append(myMats[1])
	
	if smooth :
		for f in meTmp.faces :f.smooth=1
	if center :transmat = TranslationMatrix(Vector([pos[0],pos[1],pos[2]+size[2]/2]))
	else :transmat = TranslationMatrix(Vector([pos[0]+size[0]/2,pos[1]+size[1]/2,pos[2]+size[2]/2]))
	scalemat=ScaleMatrix(scale, 4, Vector([0,1,0]))
	rotmat = RotationMatrix(180, 4, 'x')
	meTmp.transform(scalemat, recalc_normals=False, selected_only=False)
	meTmp.transform(rotmat, recalc_normals=False, selected_only=False)
	meTmp.transform(transmat, recalc_normals=False, selected_only=False)
	meshlist=meshToLists(meTmp)
	listsToLists(list,meshlist)
	newMat(mat,m)
	
def lookAround(ori) :
	sidewalk=street=building=0
	for o in range(1,2) :
		sidewalk +=string.count(ori[o],"0")	
		street +=string.count(ori[o],"1")	
		building +=string.count(ori[o],"2")
	#print"%s sidewalk" %(sidewalk)
	#print"%s street" %(street)
	#print"%s building" %(building)	
	if sidewalk>=building and sidewalk>=street: near=[0,sidewalk]
	elif street>=building and street>=sidewalk: near=[1,street]
	elif building>=street and building>=sidewalk: near=[2,building]
	#print near
	return near
	
def readVec(side) :
	a=side[0]
	c=side[1]
	try :
		lenght=sqrt((a*a)+(c*c))
	except :
		if str(a)=='-1.#IND' : a=0
		if str(c)=='-1.#IND' : c=0
		lenght=sqrt((a*a)+(c*c))
		#print "error"
	rot=atan2( c, a )*(180/pi)
	return lenght,rot
	
def writeVec(lenght,alpha,z=0) :
	beta=radians((90-alpha))
	alpha=radians(alpha)
	x=(lenght * sin(beta)) / sin(alpha+beta)
	y=(lenght * sin(alpha)) / sin(alpha+beta)
	return [x,y,z]
	
# take a vector poly list as input. turns it into a volume and optionnaly fills it.
def createPoly(list,poly,mymats,type="vector",mode="xyz",shape=[[0,0]],smooth=False,fill=True):
	if type=="coord" : poly=coordToVec(poly)
	if smooth:sm=[1]
	else : sm=[0]
	verts=[]
	edges=[]
	lpverts=[]
	lpedges=[]
	roofList=[[],[],[]]
	m=[]
	#print poly[0]
	xo,yo,zo=poly[0]
	nbv=len(poly)-1
	p=0
	if shape[0]<>[0,0] : shape.insert(0, [0,0])
	#print shape
	if len(shape)>=2 or (len(shape)==1 and fill==False) :
		for id,s in enumerate(shape) :
			# s[0] :orizontal offset / s[ 1]: height offset
			#print id
			if s[0]<>0 :
				#print "createPoly1 %s"%(poly)
				#print
				polys=polyIn([poly],s[0])
				#for xc in polys : print "createPoly2 %s"%(xc)
				poly=coordToVec(polys[0])
			xo=x=poly[0][0]
			yo=y=poly[0][1]
			zo=z=zo+s[1]
			
			verts.append([x,y,z])

			for j in range(1,len(poly)-1) :
				v=poly[j]
				i=j-1
				if i<len(poly) :
					x +=v[0]
					y +=v[1]
					if mode=="xyz" : z +=v[2]
					verts.append([x,y,z])
					if len(shape)==1 :edges.append([i,i+1])
					elif id>0:
						edges.append([p+i,p+i+1,p+i+1-nbv,p+i-nbv])
						m.append(mymats[1])
			if len(shape)==1 :edges.append([i+1,0])
			if id>0:#pass
				#edges.append([p+i,p,p-nbv,p+i-nbv])
				edges.append([p+i+1,p,p-nbv,p+i+1-nbv])
				m.append(mymats[1])
			p +=nbv
		listsToLists(roofList,[verts,edges,sm])
		
	if fill :
		#print "fill"
		x,y,z=xo,yo,zo
		lpverts.append([x,y,z])
		for j in range(1,len(poly)-1) :
			v=poly[j]
			i=j-1
			if i<len(poly) :
				x +=v[0]
				y +=v[1]
				z +=v[2]
				if mode=="xyz" : z +=v[2]
				#if id>0:
				lpverts.append([x,y,z])
				lpedges.append([i,i+1])
		lpedges.append([i+1,0])
			
		tmpPoly=Mesh.Get("tmpPoly")
		tmpPoly.verts.delete(range(len(tmpPoly.verts)))
		tmpPoly.verts.extend(lpverts)
		tmpPoly.edges.extend(lpedges)
		#print "-------------------------"
		#for v in tmpPoly.verts : print v
		#for e in tmpPoly.edges : print e
		tmpPoly.fill()
		for f in range(len(tmpPoly.faces)) :m.append(mymats[0])
		listsToLists(roofList,meshToLists(tmpPoly))
	
	listsToLists(list,roofList)

	newMat(list[3],m)
	


# determine if a point is inside a given polygon or not
def pointInPoly(x,y,poly):
	n = len(poly)
	inside =False
	#print poly
	p1x,p1y,z = poly[0]
	for i in range(n+1):
		p2x,p2y,z = poly[i % n]
		if y > min(p1y,p2y):
			if y <= max(p1y,p2y):
				if x <= max(p1x,p2x):
					if p1y != p2y:
						xinters = (y-p1y)*(p2x-p1x)/(p2y-p1y)+p1x
					if p1x == p2x or x <= xinters:
						inside = not inside
		p1x,p1y = p2x,p2y
	return inside

# input list(s)  of vectors or coords
# output list(s)  of coords (optionaly appended to original list)
def polyIn(polys,w,type="vector",list=[]) :
	global debug
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True
	newpolys=[]
	#print "polyIn1 %s"%(polys)
	if type=="coord":polys=coordToVec(polys)
	#print "polyIn2 %s"%(polys)
	tv=0.3 #test vertex (inclu ou non dans le 'gon)
	for p in polys :
		polyparent=vecToCoord(p)
		pos=p[0]
		poly2=[]
		poly=p[1:]
		v=0
		
		ax=pos[0]
		ay=pos[1]
		#print "_____________________________"
		#print p
		while v < len(poly) :
			p=v-1
			x=poly[p][0]
			y=poly[p][1]
			sz2,rot2=readVec(poly[v])
			sz2,rot1=readVec([-x,-y])
			z=0
			angle=(rot1-rot2)/2+rot2
			b=writeVec(tv,angle)
			
			#print "a %s,%s : %s"%(p,v,angle)
			
			if pointInPoly(ax+b[0],ay+b[1],polyparent)==False : 
				angle=(360+(rot1-rot2))/2+rot2
			b=writeVec(w,angle)
			
			bx=ax+b[0]
			by=ay+b[1]
			
			c=writeVec(w,90+rot2)
			c2=writeVec(w,-90+rot2)
			cx=ax+c[0]
			cy=ay+c[1]
			cx2=ax+c2[0]
			cy2=ay+c2[1]			
			l1,r=readVec([bx-cx,by-cy])
			l2,r=readVec([bx-cx2,by-cy2])
			if l2<l1 :
				cx=cx2
				cy=cy2
			dx=cx+poly[v][0]
			dy=cy+poly[v][1]
			interlist=LineIntersect(Vector([ax,ay,0]),Vector([bx,by,0]),Vector([cx,cy,0]),Vector([dx,dy,0]))
			try :
				poly2.append([interlist[0][0],interlist[0][1],poly[v][2]])
			except : # vectors are parrallel
				pass
				#print "polyIn failed"
			ax=poly[v][0]+ax
			ay=poly[v][1]+ay
			v +=1
		newpolys.append(poly2)
	#newpolys=polyClean(newpolys,type="coords")
	if len(list)>0 :
		for i,poly in enumerate(list) :
			newpolys.insert(i,poly)
	if one : return newpolys[0]
	else : return newpolys

# coords to vectors polygon lists
#
def polyInback(polys,w,type="vector",list=[]) :
	global debug
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True
	newpolys=[]
	#print "polyIn1 %s"%(polys)
	if type=="coord":polys=coordToVec(polys)
	#print "polyIn2 %s"%(polys)
	tv=0.3 #test vertex (inclu ou non dans le 'gon)
	for p in polys :
		polyparent=vecToCoord(p)
		pos=p[0]
		poly2=[]
		poly=p[1:]
		v=0
		
		ax=pos[0]
		ay=pos[1]
		
		while v < len(poly) :
			p=v-1
			x=poly[p][0]
			y=poly[p][1]
			sz2,rot2=readVec(poly[v])
			sz2,rot1=readVec([-x,-y])
			z=0
			angle=(rot1-rot2)/2+rot2
			b=writeVec(tv,angle)
			if pointInPoly(ax+b[0],ay+b[1],polyparent) : 
				b=writeVec(w,angle)
				bx=ax+b[0]
				by=ay+b[1]
			else :
				angle=(360+(rot1-rot2))/2+rot2
				b=writeVec(w,angle)
				bx=ax+b[0]
				by=ay+b[1]
			c=writeVec(w,90+rot2)
			c2=writeVec(w,-90+rot2)
			cx=ax+c[0]
			cy=ay+c[1]
			cx2=ax+c2[0]
			cy2=ay+c2[1]			
			l1,r=readVec([bx-cx,by-cy])
			l2,r=readVec([bx-cx2,by-cy2])
			if l2<l1 :
				cx=cx2
				cy=cy2
			dx=cx+poly[v][0]
			dy=cy+poly[v][1]
			interlist=LineIntersect(Vector([ax,ay,0]),Vector([bx,by,0]),Vector([cx,cy,0]),Vector([dx,dy,0]))
			try :
				poly2.append([interlist[0][0],interlist[0][1],poly[v][2]])
			except : # vectors are parrallel
				pass
				#print "polyIn failed"
			ax=poly[v][0]+ax
			ay=poly[v][1]+ay
			v +=1
		newpolys.append(poly2)
	#newpolys=polyClean(newpolys,type="coords")
	if len(list)>0 :
		for i,poly in enumerate(list) :
			newpolys.insert(i,poly)
	if one : return newpolys[0]
	else : return newpolys

# coords to vectors polygon lists
def coordToVec(polys) :
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True
	for ip,poly in enumerate(polys) :
		x=poly[0][0]
		y=poly[0][1]
		z=poly[0][2]
		vecs=[[x,y,z]]
		for i in range(len(poly)) :
			if i==len(poly)-1 : n=0
			else : n=i+1
			x=poly[n][0]-poly[i][0]
			y=poly[n][1]-poly[i][1]
			z=poly[n][2]-poly[i][2]
			if readVec([x,y,z])[0]<>0 : vecs.append([x,y,z])
		polys[ip]=vecs
	if one : return polys[0]
	else : return polys

# vectors to coords polygon lists
def vecToCoord(polys) :
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True
	for ip,poly in enumerate(polys) :
		x=y=z=0
		coords=[]
		for i,v in enumerate(poly) :
			x +=v[0]
			y +=v[1]
			z +=v[2]
			if i==len(poly)-1 and cfloat(x,"eq",poly[0][0],0.0000001) and cfloat(y,"eq",poly[0][1],0.0000001) and cfloat(z,"eq",poly[0][2],0.0000001) : pass
			else :coords.append([x,y,z])
		polys[ip]=coords
	if one :return polys[0]
	else : return polys
	


def polyInter(polys,type="vector",list=[]) :
	if len(list)>0 : list=list[:]
	if type=="vector" : 
		polys=vecToCoord(polys)
		if len(list)>0 : list=vecToCoord(list)
	i=0
	bug=False
	while i < len(polys) :
		poly=polys[i]
		s=0
		floatbug=0.0001
		redo=False
		while s < len(poly)-2 :
			s2=s+2
			lp=len(poly)
			while s2<lp :
				ax=poly[s][0]
				ay=poly[s][1]
				bx=poly[s+1][0]
				by=poly[s+1][1]
				cx=poly[s2][0]
				cy=poly[s2][1]
				if s2<lp-1 :
					dx=poly[s2+1][0]
					dy=poly[s2+1][1]
				else :
					dx=poly[0][0]
					dy=poly[0][1]
				if s==0 and s2==lp-1 : pass
				else :
					interlist=LineIntersect(Vector([ax,ay,0]),Vector([bx,by,0]),Vector([cx,cy,0]),Vector([dx,dy,0]))
					try :
						if interlist[0][0]>=min(ax,bx)-floatbug and interlist[0][0]<=max(ax,bx)+floatbug and interlist[0][0]>=min(cx,dx)-floatbug and interlist[0][0]<=max(cx,dx)+floatbug :
							if interlist[0][1]>=min(ay,by) and interlist[0][1]<=max(ay,by) and interlist[0][1]>=min(cy,dy) and interlist[0][1]<=max(cy,dy) :
								polys.append([])
								j=len(polys)-1
								polys[j]=poly[:]
								del polys[j][s2+1:]
								del polys[j][0:s+1]
								del polys[i][s+1:s2+1]
								polys[i].insert(s+1,[interlist[0][0],interlist[0][1],0])
								polys[j].insert(0,[interlist[0][0],interlist[0][1],0])
								redo=True
								break
					except : 
						pass
				s2 +=1
			if redo :
				if len(polys)>10 :
					bug=True
					redo=False
				break
			else : s +=1
		if redo :
			redo=False
		elif bug :
			break
		else :i +=1
	if len(list)>0 :
		for i,poly in enumerate(list) :
			polys.insert(i,poly)
	if type=="vector" :polys=coordToVec(polys)
	return polys

#poly angle smoother	
def polyCorners(polys,size,subd,type="vector",list=[]) :
	global debug
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True
	newpolys=[]
	newpolylast=[]
	if type=="coord":polys=coordToVec(polys)
	for i,p in enumerate(polys) :
		#print "smooth :"
		#print i
		#print p
		newpolys.append([])
		v=0
		ax=p[0][0]
		ay=p[0][1]
		az=p[0][2]
		poly=p[:]
		poly2=[]
		del poly[0]
		# origin vector global deg.
		sz0,rot0=readVec(poly[-1])
		# angle & sign between the 2 vecs
		sz0,rot2=readVec([-poly[-1][0],-poly[-1][1]])
		while v < len(poly) :
			if v>0 : 
				ax +=poly[v][0]
				ay +=poly[v][1]
				az +=poly[v][2]
				sz0,rot0=readVec(newpolys[i][-1])
				# angle & sign between the 2 vecs
				sz0,rot2=readVec([-newpolys[i][-1][0],-newpolys[i][-1][1]])
			if v==len(poly)-1 :sz1,rot1=readVec(nvverylast)
			else :sz1,rot1=readVec(poly[v])
			angle=rot1-rot2
			if angle<-180 : angle +=360
			if angle>180 : angle -=360
			if angle>0 : angle -=180
			else : angle +=180
			# 'subd' angles to achieve smooth, each with a rotInc Angle
			rotInc=angle/(subd+1)
			#print v,poly[v],int(rot2),int(rot1),int(rot0),int(angle),int(rotInc)
			#determine sizes of smooth effect (case if asked size > available vectors lenght)
			if v==0 :szfirst=min(size,sz0*0.5)
			else : szfirst=min(size,sz0)
			if v==len(poly)-1 :szlast=min(size,sz1)
			else :szlast=min(size,sz1*0.5)
			nvfirst=writeVec(sz0-szfirst,rot0,az)
			nvlast=writeVec(sz1-szlast,rot1,az)
			lfirst=writeVec(szfirst,rot0)
			llast=writeVec(szlast,rot1)
			lenght=[abs(llast[0]+lfirst[0]),abs(llast[1]+lfirst[1])]
			if v==0 :
				newpolylast=[]
				newpolys[i].append([ax+llast[0],ay+llast[1],az]) # new start position
				#newpolylast.append(nvfirst) #last vector before last smoothed angle
				nvverylast=nvfirst
			# cut a second time the last vector
			else :newpolys[i][-1]=nvfirst
			# smoothed angles calculations
			lenghtsmooth=[0,0]
			for j in range(1,subd+1) :
				sm=writeVec(1,rot0+rotInc*j)
				lenghtsmooth=[lenghtsmooth[0]+sm[0],lenghtsmooth[1]+sm[1]]
			#mmmm........
			if lenght[0] == 0 : lenght[0]=0.001
			if lenght[1] == 0 : lenght[1]=0.001
			ratio=[abs(lenghtsmooth[0]/lenght[0]),abs(lenghtsmooth[1]/lenght[1])]
			#mmmm........
			if ratio[0] == 0 : ratio[0]=0.001
			if ratio[1] == 0 : ratio[1]=0.001
			for j in range(1,subd+1) :
				sm=writeVec(1,rot0+rotInc*j)
				sm=[sm[0]/ratio[0],sm[1]/ratio[1],az]
				# add smoothed to poly
				if v> 0 :newpolys[i].append(sm)
				else : newpolylast.append(sm)
			# add next vector or end poly
			newpolys[i].append(nvlast)
			v +=1
		newpolys[i].extend(newpolylast)
	newpolys=polyClean(newpolys)
	if type=="coord":
		polys=vecToCoord(polys)
		newpolys=vecToCoord(newpolys)
	if one : return newpolys[0]
	else : return newpolys	

def polyAddC(poly) :
	newpoly=[poly[0]]
	#print poly
	for i,p in enumerate(poly) :
		if i==0 : pp=poly[-1]
		else :
			if i==len(poly)-1 : pn=poly[1]
			else : pn=poly[i+1]
			
		
			if abs(p[0])==1 and abs(p[1])==1 and Vector(p).normalize()<>Vector(pp).normalize()	and ( i==len(poly)-1 or Vector(p).normalize()<>Vector(pn).normalize() ) :
				
					if pp[0]*pp[1]==0  and pn[0]*pn[1]==0 :
						x=p[0]
						y=p[1]				
						if p[0]*p[1]>0 :
							newpoly.append([x,0,p[2]])
							newpoly.append([0,y,p[2]])
						else :
							newpoly.append([0,y,p[2]])
							newpoly.append([x,0,p[2]])
					else :
						if pp[0] <> 0 and pp[1] <> 0:
							newpoly.append([pp[0]/abs(pp[0]),pp[1]/abs(pp[1]),pp[2]])
						elif pp[0]==0 :
							newpoly.append([0,( pp[1]/abs(pp[1]) )*2,pp[2]])
						else :		
							newpoly.append([( pp[0]/abs(pp[0]) )*2,0,pp[2]])
							
						if pn[0] <> 0 and pn[1] <> 0:
							newpoly.append([pn[0]/abs(pn[0]),pn[1]/abs(pn[1]),pn[2]])
						elif pn[0]==0 :
							newpoly.append([0,( pn[1]/abs(pn[1]) )*2,pn[2]])
						else :		
							newpoly.append([( pn[0]/abs(pn[0]) )*2,0,pn[2]])
						
										
			else :
				pp=p
				#print p
				newpoly.append(p)
			#print newpoly
	#print newpoly
	#popo()
	return newpoly
	

# input list(s) of vectors/coords
# output list(s) of vectors
def polyScale(polys,fac,type="vector") :
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True
	newpolys=[]
	poly=[]
	if type=="coord":polys=coordToVec(polys)
	for i,p in enumerate(polys) :		
		for v in p :
			poly.append([v[0]*fac,v[1]*fac,v[2]])
		newpolys.append(poly[:])
		poly=[]
	if one:return newpolys[0]
	else :return newpolys
# smooth polygon with 'stairways' vectors
#poly angle smoother	
def polySmooth(polys,type="vector",list=[]) :
	global debug
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True
	newpolys=[]
	if type=="coord":polys=coordToVec(polys)
	for i,p in enumerate(polys) :
		#print "smooth :"
		#print i
		#print p
		v=1
		ax=p[0][0]
		ay=p[0][1]
		az=p[0][2]
		poly=[[ax,ay,az]]
		diagon=0
		while v < len(p) :
			vec=p[v]
			# a simple 1 1 diagonal : remember it, go append
			if abs(p[v][0])==1 and abs(p[v][1])==1 :
				if diagon==2 : poly.append(vec1)
				#print "+ diag %s :"%(p[v])
				diag=p[v]
				diagon=3
				if p[v][0]*p[v][1]>0 : check=1
				else : check=0
			elif diagon>0 : diagon -=1
			# this vec follow a simple diag - check
			if diagon==2:
				if p[v][check]==diag[check] and p[v][not(check)]==0 :
					check=not(check)
					#print "first : %s"%(p[v])
					vec1=p[v]
				else : 
					diagon=0
					#print "first cancel : %s"%(p[v])
			# this vec is the second one after a simple diag - check
			if diagon==1:
				if p[v][check]==diag[check] and p[v][not(check)]==0 :
					#print "second : %s"%(p[v])
					poly.append(diag)
				else : 
					#print "second cancel :  %s"%(p[v])
					poly.append(vec1)
					diagon=0
				
			if diagon==0 or diagon==3 :
				poly.append(vec)
			v +=1
		#print "result : %s"%(poly)
		newpolys.append(poly)
		
	if type=="coord":
		polys=vecToCoord(polys)
		newpolys=vecToCoord(newpolys)

	if one : return newpolys[0]
	else : return newpolys	
	
# smooth polygon with 'stairways' vectors
def smoothPolyVec(pos,polyvec,sm=0) :
	polycoord=vecToCoord(pos,polyvec)
	pos,polyvec=coordToVec(polycoord)
	lp=len(polyvec)
	startline=-1
	i=0
	floattest=0.1
	pangle=400
	varangle=0
	curve=False
	#print mvec[0]
	#print polyvec
	while i <= lp and lp>5 :
			contLine=False
			if i<>lp : 
				vec=[polyvec[i-1][0]+polyvec[i][0],polyvec[i-1][1]+polyvec[i][1]]
				sz,angle=readVec(vec)
				# these two vectors could be part of a line because of their shape
				if (cfloat(polyvec[i-1][0],"eq",0) and cfloat(polyvec[i][1],"eq",0)) \
				or (cfloat(polyvec[i-1][1],"eq",0) and cfloat(polyvec[i][0],"eq",0)) :
					if  min(abs(vec[0]),abs(vec[1]))<=sm :#and max(abs(vec[0]),abs(vec[1]))<=4*sm :
						# belong to the same line or new line
						if angle==pangle or i==startline+1 : #(angle>=pangle-varangle and angle<=pangle+varangle) or i==startline+1 :
							contLine=True
							pangle=angle
					#else : 
					#	startline=i+1
					#	contLine=True
			
			if contLine==False :
				#print "new %s - %s %s %s" %(polyvec[i],vec,angle,pangle)
				if startline<>-1 and i-startline>1 :
				#if i-startline>2 :
					i=startline+int((i-startline)*0.5)*2
					#print "---"
					#print startline+1,i
					for j in range(startline+1,i) :
						#print j
						polyvec[startline][0] +=polyvec[j % lp][0]
						polyvec[startline][1] +=polyvec[j % lp][1]
					del polyvec[startline+1:i]
					#	print "del %s %s" %(j % lp,polyvec[j %lp])
					#elif abs(angle-pangle)<70) :
					#	polyvec[startline-1][0] +=polyvec[startline][0]
					#	polyvec[startline-1][1] +=polyvec[startline][1]
					#	del polyvec[startline+1:i]
					
					lp=len(polyvec)
					#print i,lp,startline
					#if i==1 and lp==231 and startline==0 : pognon(0)
					#startline+=1
					i=startline
					curve=True
						#print 'line from %s to %s : %s ' %(line,i-1,polyvec[line])
				else:
					startline=i
					curve=False
				#print "begin line at %s" %(i)
				#if (angle>pangle-varangle and angle<pangle+varangle) : print "same"
				pangle=angle
			i+=1
		
	#print "end : %s" %(polyvec)
	return pos,polyvec

# used to conform the poly list to a compatible input for next operations. use it first
def polyInput(polys,pos=[],type="vector",clean=True) :
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True
	# [pos,vec0,vec1,vec2] format for vector
	if type=="vector" and len(pos)<>0 :
		for i,poly in enumerate(polys) :polys[i].insert(0,pos)
	else : pass# print "not %s"%(pos)
	# xyz format.
	for i,poly in enumerate(polys) :
		lkz=0
		for j,c in enumerate(poly) :
			if len(c)<3 :
				x=c[0]
				y=c[1]
				if type=="vector" : z=0
				else : z=lkz
				polys[i][j]=[x,y,z]
			elif type=="coord" :lkz=c[2]
		#print poly
	# clean it
	if clean :polys=polyClean(polys,type)
	if one:return polys[0]
	else :return polys

# check if polys in list cross another one (polykiller). if yes, delete it.
# works with coord
def polyInCheck(polykiller,polys,type="vector") :
	if type=="vector" :
		polys=vecToCoord(polys)
		polykiller=vecToCoord(polykiller)
	i=0
	while i<len(polys) :
		for vert in polys[i] :
			if pointInPoly(vert[0],vert[1],polykiller)==False :
				del polys[i]
				i -=1
				break
		i +=1
	if type=="vector" :polys=coordToVec(polys)
	return polys
	

# delete null vectors, merge aligned ones. add the last vector if not present
def polyClean(polys,type="vector") :
	try :
		a=polys[0][0][0]
		one=False
	except :
		polys=[polys]
		one=True

	if type=="coord" : polys=coordToVec(polys)
	#print "polyClean : %s"%(polys)
	for ip,polyvec in enumerate(polys) :
		lp=len(polyvec)
		i=1
		dlt=False
		#print polyvec
		pos=polyvec[0][:]
		while i < lp:
			if i>1 :
				# delete (almost) null vectors
				if cfloat(readVec(polyvec[i])[0],'eq',0,0.0001) :
					del  polyvec[i]
					lp=len(polyvec)
				else :
					pos=[pos[0]+polyvec[i][0],pos[1]+polyvec[i][1],pos[2]+polyvec[i][2]]
					if i==lp-1 and polyvec[i]==pos :
						del  polyvec[i]
						p=len(polyvec)
				# merge vectors with the same orientation
				#try :
				if polyvec[i][1]<>0 and polyvec[i-1][1]<>0 and (polyvec[i][0]/polyvec[i][1]) == (polyvec[i-1][0]/polyvec[i-1][1]) : dlt=True
				elif polyvec[i][1]==0 and polyvec[i-1][1]==0 and polyvec[i][0]+polyvec[i][1]+polyvec[i][2]<>0 : dlt=True
				if dlt :
					polyvec.insert(i,[polyvec[i-1][0]+polyvec[i][0],polyvec[i-1][1]+ polyvec[i][1],polyvec[i-1][2]+polyvec[i][2]])
					del polyvec[i-1]
					del polyvec[i]
					lp=len(polyvec)
					dlt=False
					# TODO
					#if cfloat(readVec(polyvec[i-1])[0],'eq',0,0.0001) :
					#	del  polyvec[i-1]
					#	lp=len(polyvec)
					i=-1
				#except :
				#	print i,lp
				#	print polyvec
				#	popo()
					
			i+=1
		polys[ip]=polyvec
		
	# return it, the same type than input type
	if type=="vector" :
		# lazzy : just to add last vector to close poly, if none
		polys=vecToCoord(polys)
		polys=coordToVec(polys)
	else : polys=vecToCoord(polys)
	if one:return polys[0]
	else :return polys

def cleanPolyVec(pos,polyvec,sm=0) :
	polycoord=vecToCoord(pos,polyvec)
	pos,polyvec=coordToVec(polycoord)
	lp=len(polyvec)
	i=0
	floattest=0.1
	dlt=False
	while i < lp:
		# delete nul vectors
		if polyvec[i][0]+polyvec[i][1]+polyvec[i][2]==0:
			del  polyvec[i]
			lp=len(polyvec)
		if i>0 : 
			# blend contiguous, same vectors
			if abs(polyvec[i][1])>0 and polyvec[i-1][1]<>0 and (polyvec[i][0]/polyvec[i][1]) == (polyvec[i-1][0]/polyvec[i-1][1]) : dlt=True
			elif polyvec[i][1]==0 and polyvec[i-1][1]==0 and polyvec[i][0]+polyvec[i][1]+polyvec[i][2]<>0 : dlt=True
			if dlt :
				polyvec.insert(i,[polyvec[i-1][0]+polyvec[i][0],polyvec[i-1][1]+ polyvec[i][1],polyvec[i-1][2]+polyvec[i][2]])
				del polyvec[i-1]
				#print polyvec[i+1]
				del polyvec[i]
				lp=len(polyvec)
				dlt=False
				if polyvec[i-1][0]+polyvec[i-1][1]+polyvec[i-1][2]==0: 
					del  polyvec[i-1]
					lp=len(polyvec)
				i=-1
		i+=1
	return pos,polyvec
	
def cfloat(x,comp,y,floattest=0.1) :
	x=float(x)
	y=float(y)
	#if y<>0 : sign=y/abs(y)
	#else : sign=1
	#floattest=floattest*sign
	if comp=="eq" :
		if x>= y-floattest and x<= y+floattest : return True
	if comp=="not" :
		if x>= y-floattest and x<= y+floattest : return True
	elif comp=="gt" :
		if x> y+floattest : return True
	elif comp=="lt" :
		if x< y-floattest : return True
	elif comp=="gte" :
		if x>= y+floattest : return True
	elif comp=="lte" :
		if x<= y-floattest : return True
	return False